/*
 * Cremetz Olivier
 * Mssiaidi Ali
 * Projet Algorithmique - Tp Jeu du Pente
 * A rendre pour le 26/11/2004
 */


#include <stdio.h>
#include <stdlib.h> // pour la fonction system

// TAILLE DE LA GRILLE
#define TAILLE 19

// NOMBRE DE PIONS ALIGNES POUR GAGNER
#define PIONS_ALIGNE 5
#define PIONS_ADVERSAIRE 10


/* CONSTANTES POUR DEFINIR UN BOOLEEN EN C */
#define VRAI 1
#define FAUX 0


/* Constantes pour definir les directions */
#define LIGNE 1
#define COLONNE 2
#define DIAG_MONTANTE 3
#define DIAG_DESCENDANTE 4



/*
  Structure permettant de dfinir un joueur
  il possde un numro
  un prenom
  un pion lui sera affect soit X ou O
  et nbpionsadv: le nombre de pions pris  son adversaire
*/
typedef struct{
  int num;
  char* prenom[20];
  char pion;
  int nbpionsadv;
}joueur;






/******************************* INITIALISATION *********************************/


/*
  Action start
  Parametre en donnee ou Resultat ou donnee/Resultat : /
  Cette procedure permet d'afficher un ecran de presentation du jeu
  Cette procedure attend juste que l'utilisateur appuie sur une touche
*/
void start()
{
  printf("\n\t\t\t CREMETZ OLIVIER ET MSSIAIDI ALI \n");
  printf(" \n\t\t\t\t TP ALGORITHMIQUE\n");
  printf(" \n\t\t\t\t   JEU DU PENTE\n");
  
  printf("\n\n\n\t\t\t Appuyez sur une touche pour continuer...");
  getchar();
}



/*
  Action creerJoueur
  Parametre en donnee/Resultat: joueur j de type joueur
  Cette procedure permet au joueur d'entrer son prenom et d'initialiser
  le compteur de prises de pions a l'adversaire
*/
void creerJoueur(joueur *joueurCourant)
{
  // On cree un joueur avec son nom  et on lui initialise son nombre de prises
  joueurCourant->nbpionsadv=0;
  printf("Entrer votre prenom joueur %d : ",joueurCourant->num);
  scanf("%s",&joueurCourant->prenom);
}    



/*
  Action initGrille
  Parametre en donnee/resultat : grille matrice carree de caracteres de TAILLE 
  Cette procedure initialise le tableau avec un espace
*/

void initGrille(char grille[TAILLE][TAILLE])
{
  int ligne,colonne;
  for (ligne=0;ligne<TAILLE;ligne++)
    {
      for (colonne=0;colonne<TAILLE;colonne++)
      	{
	  grille[ligne][colonne]=' ';
	}
    }
}


/*
  Action afficheGrille
  Parametre en donnee : grille matrice carree de caracteres de TAILLE
  Cette procedure permet d'afficher la grille du jeu
  avec les coups dja saisis
  Seuls les pions X et O sont affichs sinon on affiche un point
*/
void afficheGrille(char grille[TAILLE][TAILLE])
{
  int ligne,colonne;
  
  //On efface l'ecran
  system("clear");
  
  printf("***********************  JEU DU PENTE  ***********************\n");
  printf("%5c",' ');
  for (colonne=0;colonne<TAILLE;colonne++)
    {
      printf("%3d",colonne+1);
    }
  printf("\n");
  
  for (ligne=0;ligne<TAILLE;ligne++)
    {
      printf("%3d  ",ligne+1);
      for (colonne=0;colonne<TAILLE;colonne++)
	{
	  if(grille[ligne][colonne]=='X' || grille[ligne][colonne]=='O')
	    printf("%3c",grille[ligne][colonne]);
	  else
	    printf("%3c",'.');
	}
      printf("\n");
    }
}


/*
  Action saisie
  Parametre en donnee : joueurCourant de type Joueur 
  Parametre en donnee resultat grille matrice carree de caracteres de TAILLE
  Parametre en resultat : lignesaisie et colonnesaisie de type entier 
  Donne les coordonnees du coup joue
  Cette procedure permet de placer au joueur de placer son pion sur la grille du jeu
  Si un pion est deja a cet endroit l'ordinateur lui demandera de rejouer le coup
  Les coordonnees doivent bien sur entrer dans la grille
  On saisie d'abord la ligne puis la colonne
*/

void saisie(char grille[TAILLE][TAILLE],joueur joueurCourant,int *lignesaisie,int *colonnesaisie)
{  
  int ligne,colonne;
  int recommencer=VRAI;
  
  while (recommencer){
    printf("Joueur %d : entrez la position \nen ligne :",joueurCourant.num);
    scanf("%d",&ligne);
    printf("en colonne :");
    scanf("%d",&colonne);
    
    // Si les coordonnees sont en dehors du tableau ou si la place n'est pas libre, on recommence la saisie    
    if(ligne>=1 && ligne<=TAILLE && colonne>=1 && colonne<=TAILLE && grille[ligne-1][colonne-1]!='O' && grille[ligne-1][colonne-1]!='X')
      { 
	recommencer=FAUX;
      }
    else{
      printf("Saisie incorrecte veuillez recommencer\n");
      recommencer=VRAI;
    }  
    
  }
  //on affiche sur la grille la nouvelle position
  grille[ligne-1][colonne-1]=joueurCourant.pion; 
  
  //on renvoie la position saisie
  *lignesaisie=ligne;
  *colonnesaisie=colonne;
}




/***************** SERIE DE TEST POUR GAGNER ***************************/


/*
  Action deplacement
  parametre en donnee : direction de type entier (voir les constantes)
  paramtres en resultat : deplacLigne,deplacColonne de type entier
  Cette procedure permet de renvoyer le point de dpart pour tracer
  la droite
  en ligne :  gauche
  colonne : en haut
  diagonale montante : coin bas gauche
  diagonale descendante : coin haut gauche
*/
void deplacement(int direction, int *deplacLigne,int *deplacColonne)
{
  if(direction==LIGNE)
    {
      // En ligne on part vers la gauche 
      *deplacLigne=0;
      *deplacColonne=-1;
    }
  
  if(direction==COLONNE)
    {
      // En Colonne on part vers le haut 
      *deplacLigne=-1;
      *deplacColonne=0;
    }
  
  if(direction==DIAG_MONTANTE)
    {
      // En Diagonale montante on part vers le bas gauche 
      *deplacLigne=1;
      *deplacColonne=-1;
    }
  
  if(direction==DIAG_DESCENDANTE)
    {
      // En Diagonale descendante on part vers le haut gauche 
      *deplacLigne=-1;
      *deplacColonne=-1;
    }
  
}    





/*
  Fonction testJeuGagne renvoie un entier
  Parametres en donnee:  grille :  matrice carree de caracteres de TAILLE    
  lignesaisie, colonnesaisie : entiers representant le dernier coup jou.  
  direction : Direction  teste (LIGNE COLONNE DIAG_MONTANTE DIAG_DESCENDANTE) voir les constantes
  Cette fonction permet de tester si on a le nombre de pions alignes
  Pour des raisons de simplicite, on vrifie dans un sens (en ligne :  gauche,
  colonne : en haut, diagonale montante : coin bas gauche, diagonale descendante : coin haut gauche)
  si on a les 5 pions alignes puis on calcul le nombre de pions dans l'autre sens
*/

int testJeuGagne(char grille[TAILLE][TAILLE],int lignesaisie,int colonnesaisie,int direction)
{
  int compteur=0;
  int compteurtemporaire=0;
  char pion_a_tester=grille[lignesaisie-1][colonnesaisie-1];
  
  // on transpose le coup sur la matrice
  int i=lignesaisie-1;
  int j=colonnesaisie-1;
  
  int deplacLigne,deplacColonne;
  deplacement(direction, &deplacLigne,&deplacColonne);
  
  //on deplace dans la premiere direction (jusqu'au premier pion appartenant au joueur)
  // Quand on se dplace par la gauche on n'a pas besoin de teste si la colonne touche le cote droit
  while(i>=0 && j>=0 && i<TAILLE && grille[i+deplacLigne][j+deplacColonne]==pion_a_tester)
    {
      i=i+deplacLigne;
      j=j+deplacColonne;
      //On compte au cas ou on aurait tout dans le sens inverse
      compteurtemporaire=compteurtemporaire+1;
    }
  
  
  // Si on a deja le compte, on retourne directement le resultat on ne rentre pas dans la 2eme boucle
  if(compteurtemporaire==PIONS_ALIGNE)
    return VRAI;
  
  //on va dans l'autre sens
  // Quand on se dplace par la droite on n'a pas besoin de teste si la colonne touche le cote gauche
  while(compteur!=PIONS_ALIGNE && grille[i][j]==pion_a_tester && i>=0 && i<TAILLE && j<TAILLE)
    {
      compteur=compteur+1;
      i=i-deplacLigne;
      j=j-deplacColonne;
    }
  
  // Si on a le compte, on a gagne
  if(compteur==PIONS_ALIGNE)
    return VRAI;
  return FAUX;
}



/*
  Procedure testGagne
  Parametres en donnee:  grille :  matrice carree de caracteres de TAILLE    
  lignesaisie, colonnesaisie : entiers representant le dernier coup jou par le joueur j.
  On lance la fonction testJeuGagne dans les 4 directions (voir les constantes LIGNE COLONNE DIAG_MONTANTE et DIAG_DESCENDANTE)
*/
int testGagne(char grille[TAILLE][TAILLE],int lignesaisie,int colonnesaisie)
{
  int i;
  i=1;    
  // On test les 4 directions
  while(i<=4 && !testJeuGagne(grille,lignesaisie,colonnesaisie,i))
    {
      i=i+1;
    }
  // Si la boucle s'est arretee avant de faire toutes les directions, on a gagne
  if(i<=4)
    return VRAI;
  
  return FAUX;
}




/*********************************** ENTOURAGE D'UNE PAIRE DE PION ADVERSE ********/

/*
  Procedure supprimePion
  Parametres en donnee/resultat: 
  grille :  matrice carree de caracteres de TAILLE    
  coordV, coordH : entiers representant les coordonnees de la position a supprimer.
  On replace la case de la grille par un caractere espace
*/
void supprimePion(char grille[TAILLE][TAILLE],int coordV,int coordH)
{
  grille[coordV][coordH]=' ';
}



/*
  Procedure testEntoure
  Parametres en donnee: 
  grille :  matrice carree de caracteres de TAILLE    
  Cette grille possde tous les coups dja jous.
  lignesaisie, colonnesaisie : entiers representant le dernier coup joue par le joueur j.
  
  Parametre en donnee/resultat : joueurCourant,j1,j2 : de type dfini joueur. La structure permet de rcuperer son pion, son nombre
  de pions pris a l'adversaire.    
  
*/
void testEntoure(char grille[TAILLE][TAILLE],int lignesaisie,int colonnesaisie,joueur *joueurCourant,joueur *j1,joueur *j2)
{
  // On transpose les coordonnes representant le dernier coup joue par le joueur j dans la grille
  int i;    
  int j;
  i=lignesaisie-1;
  j=colonnesaisie-1;
  
  // On recupere le pion du joueur courant
  char pion=joueurCourant->pion;
  
  // On recupere le pion de l'adversaire
  char pionentoure;
  if(pion=='O')
    pionentoure='X';
  else
    pionentoure='O';
  
  // coordonnees du point de depart
  int deplacLigne,deplacColonne;
  // sens pour le dplacement
  int sens; 
  
  // indice de boucles
  int m;
  int n;
  
  // on teste dans les 4 directions
  for (m=1;m<=4;m++)
    {
      deplacement(m, &deplacLigne,&deplacColonne);
      
      // On teste dans la direction des deux cotes
      for (n=0;n<2;n++)
	{
	  if (n==0)
	    sens=1;
	  else
	    sens=-1;
	  
	  
	  if(i+3*sens*deplacLigne >= 0 && i+3*sens*deplacLigne <= TAILLE && j+3*sens*deplacColonne>= 0 && j+3*sens*deplacColonne <= TAILLE && (grille[i+sens*deplacLigne*1][j+sens*deplacColonne*1]==pionentoure) && (grille[i+sens*deplacLigne*2][j+sens*deplacColonne*2]==pionentoure) && (grille[i+sens*deplacLigne*3][j+sens*deplacColonne*3]==pion))
	    {
	      
	      // On incremente le nombre de pions du joueur Courant et celui du joueur
	      if (joueurCourant->num==j1->num){
		j1->nbpionsadv=j1->nbpionsadv+2;
		joueurCourant->nbpionsadv=joueurCourant->nbpionsadv+2;
	      }	 
	      else{
		j2->nbpionsadv=j2->nbpionsadv+2;
		joueurCourant->nbpionsadv=joueurCourant->nbpionsadv+2;
	      }
	      
	      // On supprime la paire de pion que l'on a entoure
	      supprimePion(grille,i+sens*deplacLigne*1,j+sens*deplacColonne*1);
	      supprimePion(grille,i+sens*deplacLigne*2,j+sens*deplacColonne*2);
	      afficheGrille(grille);
	    }
	}
    }
}



/*
  Fonction grillePleine : retourne un entier(booleen)
  Parametre en donnee : grille Matrice carree de caractere de TAILLE
  Cette procedure permet d'afficher de verifier si la grille est pleine ou pas
  On recherche Si une position ne contient pas un pion X ou O (Cela signifiera que la 
  grille n'est pas pleine)
*/
int grillePleine(char grille[TAILLE][TAILLE])  
{
  int i,j;
  
  for(i=0;i<TAILLE;i++)
    {
      for (j=0;j<TAILLE;j++)
	{
	  // Si une position de la grille ne contient pas les pions X et O	on s'arrete   
	  if(grille[i][j]!='O' && grille[i][j]!='X'){
	    return(FAUX);
	  }
	  
	} 
    }    
  return(VRAI);
}




/************************************  JOUER LE COUP *************************************/


/*
  Fonction jouerUnCoup : retourne un entier (booleen)
  Parametre en donnee: joueur joueurCourant : Le joueur Courant
  grille : Matrice carree de caractere de TAILLE
  Parametre en donnee/resultat : j1,j2 de type joueur (On met a jour les structures)
  Cette procedure permet au joueur courant d'entrer un coup 
  et de verifier si il a gagne suivant l'une des 2 conditions (nombre de prises
  ou pions alignes)
*/
int jouerUnCoup(joueur joueurCourant,joueur *j1,joueur *j2,char grille[TAILLE][TAILLE])
{
  // Coordonnees du point qu'il va saisir
  int lignesaisie,colonnesaisie;	
  
  int gagne=FAUX;
  
  printf("Joueur %d : %s [%c]\t\t Nombre de prises : %d\n",joueurCourant.num,joueurCourant.prenom,joueurCourant.pion,joueurCourant.nbpionsadv);
  // Saisie du coup
  saisie(grille,joueurCourant,&lignesaisie,&colonnesaisie);
  afficheGrille(grille);
  
  // On verifie si il a entoure son adversaire
  testEntoure(grille,lignesaisie,colonnesaisie,&joueurCourant,j1,j2);
  
  //verification si il a gagne suivant l'une des 2 conditions (nombre de prises ou pions alignes)
  gagne=testGagne(grille,lignesaisie,colonnesaisie) || joueurCourant.nbpionsadv==PIONS_ADVERSAIRE;
  
  // On renvoie le resultat
  return gagne;
}




/*
  Action changerJoueur 
  Parametre en donnee: joueur j1,j2 : Les joueur de la partie
  grille : Matrice carree de caractere de TAILLE
  Parametre en donnee/Resultat : joueurCourant de type joueur
  Cette procedure permet de changer le joueur courant
*/
void changerJoueur(char grille[TAILLE][TAILLE],joueur *joueurCourant,joueur j1, joueur j2)
{
  if(joueurCourant->num==j1.num)
    *joueurCourant=j2;
  else
    *joueurCourant=j1;       	        
}






/*
  Fonction main renvoie un entier (0 pour annoncer que le programme s'est bien deroule
  Dans cette fonction, on affiche l'ecran de demarrage, on initialise la grille
  on cree les joueurs puis on fait joueur les joueurs jusqu'a temps qu'ils aient gagnes ou
  que la grile soit pleine
*/

int main()
{
  char grille[TAILLE][TAILLE];
  int gagne=FAUX;
  
  start();
  initGrille(grille);
  
  // On cree 2 joueurs
  // Le premier aura le pion O et commencera la partie
  joueur j1;
  joueur j2;
  j1.num=1;
  j1.pion='O';
  j2.num=2;
  j2.pion='X';
  creerJoueur(&j1);
  creerJoueur(&j2);
  
  afficheGrille(grille);
  
  // On cree un joueur courant 
  joueur joueurCourant;
  // Le joueur j1 demarre la partie
  joueurCourant=j1;
  
  // Logique du jeu
  // On s'arrete des que l'on a un gagnant ou si la grille est pleine 
  while(!gagne && !grillePleine(grille))
    {
      // Le joueur courant joue un coup        
      gagne=jouerUnCoup(joueurCourant,&j1,&j2,grille);
      
      // Si le joueur n'a pas gagne, on change
      if(!gagne)
	changerJoueur(grille,&joueurCourant,j1,j2);
    }
  
  // On affiche le resultat de la partie
  system("clear");   
  if(gagne){
    printf("\n\nFelicitation %s, joueur %d: Vous avez gagne avec les pions %c\n",joueurCourant.prenom,joueurCourant.num,joueurCourant.pion);
  }
  else
    printf("\n\nMatch Nul : La grille est pleine et n'a pas de gagnants\n");
  
  return 0;
}




